// Reloj con alarma con la libreria WX
// SETA43
// windows -linux

#include <wx/wx.h>
#include <wx/spinctrl.h>
#include <wx/tglbtn.h>

#include "define.h"

char VARI[100];

time_t hora;
struct tm *phora;

int A1h=12,A1m=59,A2h,A2m,A3h,A3m;
int A1a=0,A2a=0,A3a=0;
int t1=-1,t2=-1,t3=-1;

int UMinuto;

static char meses[][12]= {"Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"};



class alarmaApp : public wxApp
{
public:
    virtual bool OnInit();
};

class alarmaFrame: public wxFrame
{
public:
    alarmaFrame(wxWindow* parent,wxWindowID id = -1);

private:
    DECLARE_EVENT_TABLE()
    
    void CambioB(wxCommandEvent& event);
    void Activar(wxCommandEvent &event);
    void Cambio(wxSpinEvent &event);
    void OnQuit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void MiTimer(wxTimerEvent& event);

    //(*Identifiers(alarmaFrame)
    static const long ID_BUTTON2;

    wxButton* Button1;
    wxStaticText* StaticText1;
    wxTextCtrl* TextCtrl2;
    wxTextCtrl* TextCtrl1;

    wxToggleButton* ToggleButton2;
    wxSpinCtrl* SpinCtrl4;
    wxSpinCtrl* SpinCtrl1;
    wxStaticText* StaticText2;
    wxStaticText* StaticText6;
    wxToggleButton* ToggleButton3;
    wxCheckBox* CheckBox3;
    wxSpinCtrl* SpinCtrl9;
    wxCheckBox* CheckBox2;
    wxSpinCtrl* SpinCtrl7;
    wxToggleButton* ToggleButton1;
    wxStaticText* StaticText3;
    wxCheckBox* CheckBox1;
    wxSpinCtrl* SpinCtrl3;
    wxStaticText* StaticText5;
    wxStaticText* StaticText7;
    wxSpinCtrl* SpinCtrl2;
    wxSpinCtrl* SpinCtrl5;
    wxStaticText* StaticText4;
    wxSpinCtrl* SpinCtrl6;
    wxSpinCtrl* SpinCtrl8;
   
};


bool alarmaApp::OnInit()
{
    alarmaFrame* Frame = new alarmaFrame(0);
    Frame->Show();
    return true;
}


DECLARE_APP(alarmaApp)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(alarmaApp)

BEGIN_EVENT_TABLE(alarmaFrame,wxFrame)

    EVT_TOGGLEBUTTON(1052, alarmaFrame::CambioB)
    EVT_CHECKBOX(1051, alarmaFrame::Activar)
    EVT_SPINCTRL(1050, alarmaFrame::Cambio)
    EVT_BUTTON(1000, alarmaFrame::OnQuit)
    EVT_TIMER(1001, alarmaFrame::MiTimer)
    EVT_MENU(wxID_ABOUT, alarmaFrame::OnAbout)
    EVT_MENU(wxID_EXIT, alarmaFrame::OnQuit)    

END_EVENT_TABLE();

alarmaFrame::alarmaFrame(wxWindow* parent,wxWindowID id)
{
//(*Initialize(alarmaFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, _("wxAlarma"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    this->SetBackgroundColour( wxColour( 255, 255, 176 ) );

#if YesWindows
    SetClientSize(wxSize(344,360));
    SetMinSize(wxSize(344,360));
    SetMaxSize(wxSize(344,360));
#else
    SetClientSize(wxSize(344,339));
    SetMinSize(wxSize(344,339));
    SetMaxSize(wxSize(344,339));
#endif

    TextCtrl1 = new wxTextCtrl(this, 1010, _("00:00:00"), wxPoint(8,48), wxSize(192,40), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    wxFont TextCtrl1Font(28,wxTELETYPE,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Courier 10 Pitch"),wxFONTENCODING_DEFAULT);
    TextCtrl1->SetFont(TextCtrl1Font);
    TextCtrl2 = new wxTextCtrl(this, 1011, _("Fecha"), wxPoint(16,104), wxSize(176,24), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    StaticText1 = new wxStaticText(this, 1012, _("wxAlarma"), wxPoint(64,16), wxSize(96,32), 0, _T("ID_STATICTEXT1"));
    wxFont StaticText1Font(16,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);
    Button1 = new wxButton(this, 1000, _("Salir"), wxPoint(96,277), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, wxID_EXIT, _("Salir\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&Menu"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, wxID_ABOUT, _("Acerca\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Ayuda"));
    SetMenuBar(MenuBar1);

    StaticText3 = new wxStaticText(this, wxID_ANY, _("Alarma1"), wxPoint(8,184), wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    StaticText4 = new wxStaticText(this, wxID_ANY, _("Alarma3"), wxPoint(8,248), wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    StaticText2 = new wxStaticText(this,wxID_ANY, _("Alarma2"), wxPoint(8,216), wxDefaultSize, 0, _T("ID_STATICTEXT2"));

    SpinCtrl2 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(67,176), wxSize(45,27), 0, 0, 23, 0, _T("ID_SPINCTRL2"));
    SpinCtrl2->SetValue(_T("0"));
    SpinCtrl3 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(67,240), wxSize(45,27), 0, 0, 23, 0, _T("ID_SPINCTRL3"));
    SpinCtrl3->SetValue(_T("0"));
    SpinCtrl1 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(67,208), wxSize(45,27), 0, 0, 23, 0, _T("ID_SPINCTRL1"));
    SpinCtrl1->SetValue(_T("0"));
    SpinCtrl5 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(112,176), wxSize(45,27), 0, 0, 59, 0, _T("ID_SPINCTRL5"));
    SpinCtrl5->SetValue(_T("0"));
    SpinCtrl6 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(112,240), wxSize(45,27), 0, 0, 59, 0, _T("ID_SPINCTRL6"));
    SpinCtrl6->SetValue(_T("0"));
    SpinCtrl4 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(112,208), wxSize(45,27), 0, 0, 59, 0, _T("ID_SPINCTRL4"));
    SpinCtrl4->SetValue(_T("0"));
    SpinCtrl9 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(160,176), wxSize(48,27), 0, 0, 999, 0, _T("ID_SPINCTRL9"));
    SpinCtrl9->SetValue(_T("0"));
    SpinCtrl8 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(160,208), wxSize(48,27), 0, 0, 999, 0, _T("ID_SPINCTRL8"));
    SpinCtrl8->SetValue(_T("0"));
    SpinCtrl7 = new wxSpinCtrl(this, 1050, _T("0"), wxPoint(160,240), wxSize(48,27), 0, 0, 999, 0, _T("ID_SPINCTRL7"));
    SpinCtrl7->SetValue(_T("0"));

    StaticText5 = new wxStaticText(this, wxID_ANY, _("Hora"), wxPoint(72,152), wxDefaultSize, 0, _T("ID_STATICTEXT5"));
    wxFont StaticText5Font(7,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText5->SetFont(StaticText5Font);
    StaticText6 = new wxStaticText(this, wxID_ANY, _("Minutos"), wxPoint(112,152), wxDefaultSize, 0, _T("ID_STATICTEXT6"));
    wxFont StaticText6Font(7,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText6->SetFont(StaticText6Font);
    StaticText7 = new wxStaticText(this, wxID_ANY, _("Tiempo\nMinutos"), wxPoint(160,152), wxDefaultSize, 0, _T("ID_STATICTEXT7"));
    wxFont StaticText7Font(7,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText7->SetFont(StaticText7Font);

    CheckBox3 = new wxCheckBox(this, 1051, _("Activa"), wxPoint(210,176), wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX3"));
    CheckBox3->SetValue(false);
    CheckBox2 = new wxCheckBox(this, 1051, _("Activa"), wxPoint(210,208), wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX2"));
    CheckBox2->SetValue(false);
    CheckBox1 = new wxCheckBox(this, 1051, _("Activa"), wxPoint(210,240), wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
    CheckBox1->SetValue(false);
    ToggleButton3 = new wxToggleButton(this, 1052,  _("OFF"), wxPoint(288,176), wxSize(40,27), 0, wxDefaultValidator, _T("ID_TOGGLEBUTTON3"));
    ToggleButton2 = new wxToggleButton(this, 1052,  _("OFF"), wxPoint(288,208), wxSize(40,27), 0, wxDefaultValidator, _T("ID_TOGGLEBUTTON2"));
    ToggleButton1 = new wxToggleButton(this, 1052,  _("OFF"), wxPoint(288,240), wxSize(40,27), 0, wxDefaultValidator, _T("ID_TOGGLEBUTTON1"));
 
    wxTimer *MiTimer= new wxTimer();
    MiTimer->SetOwner(this, 1001); //identificador de evento
    MiTimer->Start(1000);	// cada segundo
}


void alarmaFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void alarmaFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg;
    msg.Printf(wxT("wxAlarma\nxsetaseta@gmail.com\n%s"),	wxVERSION_STRING);
    wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
}

void alarmaFrame::CambioB(wxCommandEvent& event)
{
	if(ToggleButton3->GetValue()==true)
		ToggleButton3->SetLabel(wxT("ON"));
	else
		ToggleButton3->SetLabel(wxT("OFF"));
		
	if(ToggleButton2->GetValue()==true)
		ToggleButton2->SetLabel(wxT("ON"));
	else
		ToggleButton2->SetLabel(wxT("OFF"));
	
	if(ToggleButton1->GetValue()==true)
		ToggleButton1->SetLabel(wxT("ON"));
	else
		ToggleButton1->SetLabel(wxT("OFF"));
	
}	

void alarmaFrame::MiTimer(wxTimerEvent& event)
{

    //Button1->SetFocus();

    hora= time( NULL );
    //phora = gmtime( &hora );
	phora = localtime( &hora );

    //sprintf(VARI,"%dM%dD%dH%dM%dS",(phora->tm_mon+1),phora->tm_mday,phora->tm_hour,phora->tm_min, phora->tm_sec );
    sprintf(VARI,"%02d:%02d:%02d",phora->tm_hour,phora->tm_min, phora->tm_sec );
    wxString  msg(VARI, wxConvUTF8);
    TextCtrl1->SetValue(msg);

    //sprintf(VARI,"%d-%d-%d",phora->tm_mday,(phora->tm_mon+1), (phora->tm_year+1900));
    sprintf(VARI,"%d-%s-%d",phora->tm_mday,meses[(phora->tm_mon)], (phora->tm_year+1900));
    wxString string1(VARI, wxConvUTF8);
    TextCtrl2->SetValue(string1);

    if(A1a==1 && phora->tm_hour==A1h && phora->tm_min==A1m && phora->tm_sec==0)
    {
  #if DEBUG
        printf("Alarma1_ON\n");
  #endif
        ToggleButton3->SetValue(true);
        ToggleButton3->SetLabel(wxT("ON"));
        t1=SpinCtrl9->GetValue();
    }
    if(A2a==1 && phora->tm_hour==A2h && phora->tm_min==A2m && phora->tm_sec==0)
    {
		#if DEBUG
        printf("Alarma2_ON\n");
        #endif
        ToggleButton2->SetValue(true);
        ToggleButton2->SetLabel(wxT("ON"));
        t2=SpinCtrl8->GetValue();
    }
    if(A3a==1 && phora->tm_hour==A3h && phora->tm_min==A3m && phora->tm_sec==0)
    {
		#if DEBUG
        printf("Alarma3_ON\n");
         #endif
        ToggleButton1->SetValue(true);
        ToggleButton1->SetLabel(wxT("ON"));
        t3=SpinCtrl7->GetValue();
    }
    if(phora->tm_min != UMinuto)
    {
        //A pasado un minuto
        UMinuto=phora->tm_min;

        if(t1>0)
        {
            t1--;
        }
        else
        {
            if(A1a==1 && t1>=0)
            {
				#if DEBUG
                printf("Alarma1_OFF\n");
                 #endif
                ToggleButton3->SetValue(false);
                ToggleButton3->SetLabel(wxT("OFF"));
                t1=-1;
            }
        }
        if(t2>0)
        {
            t2--;
        }
        else
        {
            if(A2a==1 && t2>=0)
            {
				#if DEBUG
                printf("Alarma2_OFF\n");
                 #endif
                ToggleButton2->SetValue(false);
                ToggleButton2->SetLabel(wxT("OFF"));
                t2=-1;
            }
        }
        if(t3>0)
        {
            t3--;
        } 
        else
        {
            if(A3a==1 && t3>=0)
            {
				#if DEBUG
                printf("Alarma3_OFF\n");
                 #endif
                ToggleButton1->SetValue(false);
                ToggleButton1->SetLabel(wxT("OFF"));
                t3=-1;
            }
        }
    }

}

void alarmaFrame::Activar(wxCommandEvent& event)
{

    A3a=CheckBox1->GetValue();
    A2a=CheckBox2->GetValue();
    A1a=CheckBox3->GetValue();
#if DEBUG
    printf("Activas %d   %d   %d\n",A1a,A2a,A3a);
 #endif    
}

void alarmaFrame::Cambio(wxSpinEvent &event)
{
    A1h=SpinCtrl2->GetValue();
    A1m=SpinCtrl5->GetValue();
    A2h=SpinCtrl1->GetValue();
    A2m=SpinCtrl4->GetValue();
    A3h=SpinCtrl3->GetValue();
    A3m=SpinCtrl6->GetValue();
#if DEBUG
    printf("Alarmas A1-%d:%d  A2-%d:%d  A3-%d:%d\n",A1h,A1m,A2h,A2m,A3h,A3m);
 #endif    

}
